<%--
 * Component: imadmin
 *
 * Description:
 *  Maintaining registered Callback URLs and trigger actions
 *
 * Parameters:
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="imagemed.scheduler.SchedulerInterface"%>
<%@
	page import="java.util.*, java.io.*, java.sql.*, java.net.*, java.text.Format,
			imagemed.exception.*, imagemed.imsession.*, imagemed.util.*, imagemed.jsputil.*, imagemed.tables.*,
			imagemed.imtables.*, imagemed.types.enumeration.IMTypeACTN, imagemed.types.flag.IMTypeur,
			imagemed.layout.datasource.*, imagemed.layout.LayoutPart"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%-- --- Helper Function(s) --- --%><%!static String m_DEFAULT_FIELDS = "0LAC\n0LLD\n0LPA\nSYUI\n0LUI";


	/**
	 * Prints a HTML code to edit a callback hook
	 *
	 * @param is        session info (including output to write on and request parameters)
	 * @param oper      edit operation ('new' or 'edit')
	 * @param errorMsg  error message to display (if any)
	 *
	 * @throw IOException  if an I/O error occurs
	 * @throw SQLException  if an SQL error occurs
	 */
	static void printEditPage( IMSession is, String oper, String errorMsg ) throws IOException, SQLException {
		String id = is.request.getParameter( "cID" );
		String url = is.request.getParameter( "cURL" );
		String format = is.request.getParameter( "cFormat" );
		boolean isEnabled = "true".equals( is.request.getParameter( "cEnable" ) );
		String parActions = is.request.getParameter( "cAction" );
		String parFields = is.request.getParameter( "cField" );
		TreeSet<String> actions = new TreeSet<String>();
		TreeSet<String> fields = new TreeSet<String>();

		if ( parActions == null ) {
			parActions = "";
		}
		if ( parFields == null ) {
			parFields = m_DEFAULT_FIELDS;
		}
		
		if ( !"".equals( parActions ) ) {
			StringTokenizer tokenizer = new StringTokenizer( parActions, "\n" );
			while ( tokenizer.hasMoreTokens() ) {
				actions.add( tokenizer.nextToken().trim() );
			}
		}
		
		if ( !"".equals( parFields ) ) {
			StringTokenizer tokenizer = new StringTokenizer( parFields );
			while ( tokenizer.hasMoreTokens() ) {
				fields.add( tokenizer.nextToken().trim() );
			}
		}
		
		if ( id != null && ! "new".equals( oper ) ) {
			if ( url == null ) {
				ResultSet rs = IMEnv.getDB().prepareStatement( "select URL, FORMAT, ACTIVE, FIELDS from " + IMEnvBase.getEnv( "CALLBACKURLTBL" ) + " where CBNAME='" + id + "'" ).executeQuery();
				if ( rs.next() ) {
					url = rs.getString( "URL" );
					format = rs.getString( "FORMAT" );
					isEnabled = "yes".equals( rs.getString( "ACTIVE" ) );
					fields.clear();
					String fld = rs.getString( "FIELDS" );
					if ( fld != null ) {
						StringTokenizer tokenizer = new StringTokenizer( fld );
						while ( tokenizer.hasMoreTokens() ) {
							fields.add( tokenizer.nextToken().trim() );
						}
					}
				}
				rs.close();
			}
			if ( "".equals( parActions ) ) {
				ResultSet rs = IMEnv.getDB().prepareStatement( "select LOGACTION from " + IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) + " where CBNAME='" + id + "' order by LOGACTION" ).executeQuery();
				while ( rs.next() ) {
					actions.add( rs.getString( "LOGACTION" ) );
				}
				rs.close();
			}
		}
		
		String titleID = id == null ? "IMADMIN_CALLBACK_TITLE_NEW" : "IMADMIN_CALLBACK_TITLE_EDIT"; 
	
		is.out.println( "<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 WIDTH=\"100%\">" );
		is.out.print( "<TR><td class=BgShadow colspan=2 style=\"padding:15px 10px; font-size: larger;\">" );
		is.out.print( LocalizedMessage.getSimpleMessage( titleID ) );

		if ( errorMsg != null ) {
			is.out.print( "<SPAN style=\"font-size: smaller; margin-left: 20px; padding: 10px;\" class=\"FontError\" style=\"text-align: center; font-weight: bold;\">" );
			is.out.print( Helper.htmlEncode( errorMsg ) );
			is.out.println( "</SPAN>" );
		}

		is.out.println( "</td></TR>" );

		is.out.print( "<TR class=HeaderRow>" );
		is.out.print( Helper.headerCell3D( LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" ), "center", 1 ) );
		is.out.print( Helper.headerCell3D( LocalizedMessage.getSimpleMessage( "GENERIC_VALUE" ), "center", 1 ) );
		is.out.println( "</TR>" );

		String msgID = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ID" );
		String msgURL = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_URL" );
		String msgFormat = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_FORMAT" );
		String msgEnable = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ENABLE" );
		String msgActions = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TRIGGERS" );
		String msgFields = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_FIELDS" );
		String msgSave = LocalizedMessage.getSimpleMessage( "ALT_TEXT_SAVE" );
		String msgCancel = LocalizedMessage.getSimpleMessage( "ALT_TEXT_CANCEL" );

		String optionText = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_FORMAT_TEXT" );
		String optionXML = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_FORMAT_XML" );

		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgID + "</TD><TD class=BgShadow>" );
		if ( id == null ) {
			is.out.print( "<INPUT TYPE=\"TEXT\" NAME=\"cID\" VALUE=\"\" SIZE=16 MAXSIZE=16>" );
		}
		else if ( "new".equals( oper ) ) {
			is.out.print( "<INPUT TYPE=\"TEXT\" NAME=\"cID\" VALUE=\"" + Helper.htmlEncode( id ) + "\" SIZE=16 MAXSIZE=16>" );
		}
		else {
			is.out.print( "<INPUT TYPE=\"HIDDEN\" NAME=\"cID\" VALUE=\"" + Helper.htmlEncode( id ) + "\">" );
			is.out.println( Helper.htmlEncode( id ) );
		}
		is.out.println( "</TD></TR>" );
		
		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgEnable + "</TD><TD class=BgShadow>" );
		is.out.print( "<INPUT TYPE=\"CHECKBOX\" NAME=\"cEnable\" VALUE=\"true\"" );
		if ( isEnabled ) {
			is.out.print( " checked" );
		}
		is.out.print( ">" );
		is.out.println( "</TD></TR>" );

		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgURL + "</TD><TD class=BgShadow>" );
		is.out.print( "<INPUT TYPE=\"TEXT\" NAME=\"cURL\" VALUE=\"" + Helper.htmlEncode( url ) + "\" style=\"width: 80%;\" MAXSIZE=128>" );
		is.out.println( "</TD></TR>" );
		
		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgFormat + "</TD><TD class=BgShadow>" );
		is.out.print( "<SELECT NAME=\"cFormat\">" );
		is.out.print( "<OPTION VALUE=\"TEXT\"" );
		if ( "TEXT".equals( format ) ) {
			is.out.print( " selected" );
		}
		is.out.print( ">" + optionText + "</OPTION>" );
		is.out.print( "<OPTION VALUE=\"XML\"" );
		if ( !"TEXT".equals( format ) ) {
			is.out.print( " selected" );
		}
		is.out.print( ">" + optionXML + "</OPTION>" );
		
		is.out.print( "</SELECT>" );
		is.out.println( "</TD></TR>" );

		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgActions + "</TD><TD class=BgShadow>" );
		is.out.println( "<INPUT id=\"actionsHidden\" TYPE=hidden name=\"cAction\" value=\"" + Helper.htmlEncode( parActions )+ "\">" );
		is.out.print( "<TABLE border=0 cellpadding=0 cellspacing=0 width=\"100%\"><TR><TD width=\"60%\">" );
		is.out.println( "<DIV id=\"actionsDiv\" class=\"BgMedLight\" style=\"height: 100px; width: 100%; overflow: auto;\"></DIV>" );
		is.out.println( "</TD><TD style=\"padding: 20px\">" );
		is.out.println( "<SELECT id=\"actionsSelect\" multiple name=\"cSelectAction\" size=200 style=\"display: none;\">" );
		for ( String act : actions ) {
			is.out.print( "<OPTION VALUE=\"" + Helper.htmlEncode( act )+ "\">" );
			is.out.println( Helper.htmlEncode( act )+ "</OPTION>" );
		}
		is.out.println( "</SELECT>" );
		is.out.println( "<SCRIPT language=\"JavaScript\">initDivHidden( 'actionsSelect', 'actionsDiv', 'actionsHidden' );</SCRIPT>" );
		is.out.println( "<SELECT multiple name=\"cAllAction\" size=10 style=\"display: none;\">" );
//		for ( String i : IMTypeACTN.STUDY_LEVEL_ACTIONS ) {
		for ( String i : IMTypeACTN.ALLACTIONS ) {
			is.out.print( "<OPTION TITLE=\"" + Helper.htmlEncode( i )+ "\" VALUE=\"" + Helper.htmlEncode( i )+ "\">" );
			is.out.println( Helper.htmlEncode( i )+ "</OPTION>" );
		}
		is.out.println( "</SELECT>" );
		
		String titleSelectedActions = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TITLE_SELECTED_ACTIONS" );
		String titleAvailableActions = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TITLE_AVAILABLE_ACTIONS" );
		String altSelectActions = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ALT_SELECT_ACTIONS" );
		
		is.out.print( "<A HREF=\"javascript:openSelectLayer( 'actions', '" + titleSelectedActions + "', '" +
				titleAvailableActions + "', self.document.callbackFrm.cSelectAction, self.document.callbackFrm.cAllAction );\" title=\"" +
				altSelectActions + "\">" );
		is.out.println( Button.getJsImage( is, "editColumns", 24, 24, "" ) + "</A></TD></TR></TABLE>" );
		is.out.println("</TD></TR>" );

		
		IMBaseFieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.SCHLOGLAYOUT );
		String[] logFields = fm.getFields();

		is.out.print( "<TR><TD class=\"BgMedDark\">" + msgFields + "</TD><TD class=BgShadow>" );
		is.out.println( "<INPUT id=\"fieldsHidden\" TYPE=hidden name=\"cField\" value=\"" + Helper.htmlEncode( parFields ) + "\">" );
		is.out.print( "<TABLE border=0 cellpadding=0 cellspacing=0 width=\"100%\"><TR><TD width=\"60%\">" );
		is.out.println( "<DIV id=\"fieldsDiv\" class=\"BgMedLight\" style=\"height: 100px; width: 100%; overflow: auto;\"></DIV>" );
		is.out.println( "</TD><TD style=\"padding: 20px\">" );
		is.out.println( "<SELECT id=\"fieldsSelect\" multiple name=\"cSelectedFields\" size=10 style=\"display: none;\">" );
		for ( String fld : fields ) {
			is.out.print( "<OPTION TITLE=\"" + Helper.htmlEncode( IMBaseFieldManager.getTableUiName( fm.getTableName( fld ) ) + ": " + fm.getHeaderName( fld ) ) + "\" VALUE=\"" + fld + "\">" );
			is.out.println( Helper.htmlEncode( fm.getTableName( fld ) + ": " + fm.getHeaderName( fld ) )+ "</OPTION>" );
		}
		is.out.println( "</SELECT>" );
		is.out.println( "<SCRIPT language=\"JavaScript\">initDivHidden( 'fieldsSelect', 'fieldsDiv', 'fieldsHidden' );</SCRIPT>" );
		is.out.println( "<SELECT multiple name=\"cAllFields\" size=10 style=\"display: none;\">" );
		for ( String fld : logFields ) {
			is.out.print( "<OPTION TITLE=\"" + Helper.htmlEncode( IMBaseFieldManager.getTableUiName( fm.getTableName( fld ) ) + ": " + fm.getHeaderName( fld ) ) + "\" VALUE=\"" + fld + "\">" );
			is.out.println( Helper.htmlEncode(fm.getTableName( fld ) + ": " + fm.getHeaderName( fld ) )+ "</OPTION>" );
		}
		is.out.println( "</SELECT>" );

		
		String titleSelectedFields = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TITLE_SELECTED_FIELDS" );
		String titleAvailableFields = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TITLE_AVAILABLE_FIELDS" );
		String altSelectFields = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ALT_SELECT_FIELDS" );

		is.out.print( "<A HREF=\"javascript:openSelectLayer( 'fields', '" + titleSelectedFields + "', '" +
				titleAvailableFields + "', self.document.callbackFrm.cSelectedFields, self.document.callbackFrm.cAllFields );\" title=\"" +
				altSelectFields + "\">" );
		is.out.println( Button.getJsImage( is, "editColumns", 24, 24, "" ) + "</A></TD></TR></TABLE>" );
		is.out.println("</TD></TR>" );
		
		
		is.out.println( "<TR><TD colspan=2 align=right class=BgShadow style=\"padding-top: 10px; padding-bottom: 10px;\">" );
		is.out.print( "<SPAN style=\"padding-right: 15px;\">" );
		is.out.print( "<A HREF=\"javascript:submitForm( 'save" + oper + "' );\" title=\"" + msgSave + "\" onMouseOver=\"window.status='" + msgSave + "'; return true\">" );
		is.out.print( JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "BUTTON_SAVE", false ) );
		is.out.println( "</a></SPAN>" );
		
		is.out.print( "<SPAN style=\"padding-right: 15px;\">" );
		is.out.print( "<A HREF=\"javascript:submitForm( '' );\" title=\"" + msgCancel + "\" onMouseOver=\"window.status='" + msgCancel + "'; return true\">" );
		is.out.print( JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_CANCEL", false ) );
		is.out.println( "</a></SPAN>" );
		is.out.println( "</TD></TR></TABLE>" );
	}


	/**
	 * Prints a HTML table listing all callback hooks
	 *
	 * @param is        session info (including output to write on)
	 * @param backURL   URL for the back button
	 *
	 * @throw IOException  if an I/O error occurs
	 * @throw IMException  if any other error occurs
	 */
	static void printListPage( IMSession is, String backURL ) throws IOException, IMException {
		TableDescriptor tdesc = new TableDescriptor( "/imadmin/callbacks.jsp", false, false, false, false );
		TableProperties tprop = new TableProperties();
		
		TableParams tparams = new TableParams();
		tparams.setDefaults( "/imadmin/callbacks.jsp", is );
		tdesc.setTableParams( tparams );
		tdesc.setTableProperties( tprop );
		tdesc.setFieldManager( new IMSQLFieldManager( IMEnvBase.getEnv( "FIELDSTBL" ), IMEnvBase.getEnv( "TYPESTBL" ), new String[] { IMEnvBase.getEnv( "CALLBACKURLTBL" ), IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) } ) );

		Action acts[] = new Action[2];

		acts[ 0 ] = new LinkAction( tdesc, "CBID", "javascript:submitFormID( \"delete\", \"$$CBID$$\" );",
				"<script language=javascript>getImage2node(false, \"delete.gif\", 0, 0, \"" +
				LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_DELETE_ALT" ) + "\");" +
				"</script>", null );

		acts[ 1 ] = new LinkAction( tdesc, "CBID", "javascript:submitFormID( \"edit\", \"$$CBID$$\" );",
				"<script language=javascript>getImage2node(false, \"edit.gif\", 0, 0, \"" +
				LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_EDIT_ALT" ) + "\");" +
				"</script>", null);

		Column col = new Column( new SimpleHeader( "&nbsp;" ), new ActionCell( "BCID", acts ), "BCID");

		tdesc.addExtraColumn("_FIRST",col);

		Properties buttonCellPrp = new Properties();
		buttonCellPrp.setProperty( "align", "left" ); 
		buttonCellPrp.setProperty( "style", "text-align: left; padding-left: 30px" ); 
		
		List<TopCell> topCells = new ArrayList<TopCell>();
		topCells.add( new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TITLE_LIST" ) ) );
		String msgNewCallback = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ADD" );
		topCells.add( new SimpleTopCell( tprop,
				"<A HREF=\"javascript:submitForm( 'new' );\" title=\"" + msgNewCallback +
				"\" onMouseOver=\"window.status='" + msgNewCallback + "'; return true\">" +
				JSHelper.getJsButton( is, "newButton", msgNewCallback ) + "</a>", buttonCellPrp ) );

		Properties backCellPrp = new Properties();
		backCellPrp.setProperty( "align", "right" );
		topCells.add( new SimpleTopCell( tprop, "<a href=\"" + backURL +
					"\"><script language=\"JavaScript\">getButtonFull(\"backButton\", 24, 24, \"\");</script></a>", backCellPrp ) );
		
		tdesc.setTopCells(topCells);

		DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.CALLBACKLAYOUT );
		DBLDSWrapperNatSqlResult result = new DBLDSWrapperNatSqlResult( tdesc, dblds );
		
		tdesc.setResult( result );

		Table table = new Table( tdesc );

		table.printTableTop( is );
		table.print( is );
	}

	/**
	 * Saves changes for a callback hook
	 *
	 * @param is        session info (including output to write on and request parameters)
	 *
	 * @return error message if an error occured during save or null on success
	 */
	static String doSave( IMSession is ) {
		String id = is.request.getParameter( "cID" );
		String url = is.request.getParameter( "cURL" );
		String format = is.request.getParameter( "cFormat" );
		boolean isEnabled = "true".equals( is.request.getParameter( "cEnable" ) );
		String parActions = is.request.getParameter( "cAction" );
		String parFields = is.request.getParameter( "cField" );
		Vector<String> actions = new Vector<String>();

		if ( "".equals( id ) ) {
			id = null;
		}
		
		if ( id == null || !Helper.containsOnly( id, "0..9a..zA..Z_.-" ) ) { 
			String msgID = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ID" );
			return LocalizedMessage.getCompoundMessage( "IMADMIN_CALLBACK_BAD_ID", new Format[] { null }, new Object[] { msgID }, true );
		}

		if ( url == null || "".equals( url ) ) {
			String msgURL = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_URL" );
			return LocalizedMessage.getCompoundMessage( "IMADMIN_CALLBACK_EMPTY_URL", new Format[] { null }, new Object[] { msgURL }, true  );
		}
		
		try {
			String msgActions = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_TRIGGERS" );
			if ( url.startsWith ( "file:///" ) ) {
				String dirName = url.substring( 7 );
				if ( dirName.length() < 2 ) {
					throw new MalformedURLException( "URL points to invalid directory '" + dirName + "'" );
				}
				File targetDir = new File( dirName );
				if ( !targetDir.isDirectory() ) {
					throw new MalformedURLException( "URL points to non existing directory '" + dirName + "'" );
				}
			}
			else {
				URL testURL = new URL( url );
				if ( ! url.startsWith( "http:" ) && ! url.startsWith( "https:" ) ) {
					// We support only http(s) callbacks
					throw new MalformedURLException();
				}
			}
		}
		catch ( MalformedURLException ex ) {
			String msgURL = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_URL" );
			return LocalizedMessage.getCompoundMessage( "IMADMIN_CALLBACK_MALFORMED_URL", new Format[] { null }, new Object[] { msgURL }, true  );
		}

		if ( parActions != null ) {
			for ( StringTokenizer st = new StringTokenizer( parActions, "\n\r" ); st.hasMoreTokens(); ) {
				actions.add( st.nextToken() );
			}
		}
		
		if ( actions.isEmpty() ) {
			return LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_NO_TRIGGER_ACTION" );
		}

		if ( parFields == null || "".equals( parFields.trim() ) ) {
			return LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_NO_FIELD" );
		}
		
		StringBuilder fields = new StringBuilder( parFields.length() );
		for ( StringTokenizer st = new StringTokenizer( parFields ); st.hasMoreTokens(); ) {
			fields.append( ' ' ).append( st.nextToken() );
		}
		
		long logNow = System.currentTimeMillis() + 2000; // Add two seconds to now to avoid current entries being triggered

		String insertQuery = "insert into " + IMEnvBase.getEnv( "CALLBACKURLTBL" ) +
				" (CBNAME, URL, FORMAT, FIELDS, LASTLOGDATE, LASTLOGTIME, LASTLOGID) VALUES ( '" + Helper.sqlEncode( id ) +
				"', '" + Helper.sqlEncode( url ) + "','" + Helper.sqlEncode( format ) + "','" + Helper.sqlEncode( fields.substring( 1 ) ) + "','" +
				Helper.longToDate( logNow ) + "','" + Helper.longToTime( logNow ) + "', 0 )";

		String updateQuery = "update " + IMEnvBase.getEnv( "CALLBACKURLTBL" ) + " set URL='" +
				Helper.sqlEncode( url ) + "', FORMAT='" + Helper.sqlEncode( format ) + "', FIELDS='" +
				Helper.sqlEncode( fields.substring( 1 ) ) + "' where CBNAME='" + Helper.sqlEncode( id ) + "'";

		boolean isNew = true;
		
		try {
			try {
				//trying to insert to objecttable
				PreparedStatement ps = IMEnv.getDB().prepareStatement( insertQuery );
				boolean wasInserted = 0 != ps.executeUpdate();
				ps.close();
	
				if ( !wasInserted ) {
					//nothing was inserted, try to update
					isNew = false;
					ps = IMEnv.getDB().prepareStatement( updateQuery );
					ps.executeUpdate();
					ps.close();
				}
			}
			catch ( SQLException sqlEx ) {//if insertion to object table fails
				int nSqlErrorCode = sqlEx.getErrorCode();
				if ( nSqlErrorCode != 1062 ) {
					// Not duplicate entry
					throw sqlEx;
				}
				
				isNew = false;
				PreparedStatement ps = IMEnv.getDB().prepareStatement( updateQuery );
				ps.executeUpdate();
				ps.close();
			}
	
			Properties logFields = new Properties();
			if ( isNew ) {
				logFields.setProperty( "0LAC", "Create" );
			}
			else {
				logFields.setProperty( "0LAC", "Edit" );
			}
			logFields.setProperty( "0LTA", OperLogEntry.LEVEL.CALLBACK.getName() );
			logFields.setProperty( "0LCN", id );
			
			// we use Information, too, because if record is deleted, other fields will disappear, too
			logFields.setProperty( "0LIN", "Name of the callback is:" + id );
			SchedulerInterface.logIntoTable( is, logFields );

			// Enable/Disable
			boolean dbActive = isEnabled;
			ResultSet rsActive = IMEnv.getDB().prepareStatement( "select ACTIVE from " +
					IMEnvBase.getEnv( "CALLBACKURLTBL" ) + " where CBNAME='" + Helper.sqlEncode( id ) + "'" ).executeQuery();
			if ( rsActive.next() ) {
				dbActive = "yes".equals( rsActive.getString( "ACTIVE" ) );
			}
			rsActive.close();

			if ( dbActive ^ isEnabled ) {
				// Active flag to be changed
				StringBuilder sbQuery = new StringBuilder();
				sbQuery.append( "update " ).append( IMEnvBase.getEnv( "CALLBACKURLTBL" ) ).append( " SET ACTIVE=" );
				if ( isEnabled ) {
					sbQuery.append( "'yes', LASTLOGDATE='").append( Helper.longToDate( logNow ) )
							.append( "', LASTLOGTIME='" ).append( Helper.longToTime( logNow ) ).append( "', LASTLOGID=0" );
				}
				else {
					sbQuery.append( "'no'" );
				}
				sbQuery.append( " where CBNAME='" ).append( Helper.sqlEncode( id ) ).append( "'" );
				PreparedStatement ps = IMEnv.getDB().prepareStatement( sbQuery.toString(  ) );
				ps.executeUpdate();
				ps.close();
			}
			
			// Update trigger actions
			TreeSet<String> addActions = new TreeSet<String>( actions );
			TreeSet<String> removeActions = new TreeSet<String>();
			
			ResultSet rs = IMEnv.getDB().prepareStatement( "select LOGACTION from " +
					IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) + " where CBNAME='" + Helper.sqlEncode( id ) + "'" ).executeQuery();
			while ( rs.next() ) {
				String a = rs.getString( "LOGACTION" );
				if ( a != null && ! addActions.remove( a ) ) {
					removeActions.add( a );
				}
			}
			rs.close();
	
			PreparedStatement psInsert = IMEnv.getDB().prepareStatement( "insert into " +
					IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) + " ( CBNAME, LOGACTION ) VALUES ( '" +
					Helper.sqlEncode( id ) + "', ? )" );
			
			PreparedStatement psDelete = IMEnv.getDB().prepareStatement( "DELETE FROM " +
					IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) +
					" where CBNAME = '" + Helper.sqlEncode( id ) + "' and LOGACTION=?" );
	
			
			for ( Iterator<String> iter = removeActions.iterator(); iter.hasNext(); ) {
				psDelete.setString( 1, iter.next() );
				psDelete.executeUpdate();
			}
			psDelete.close();
	
			for ( Iterator<String> iter = addActions.iterator(); iter.hasNext(); ) {
				psInsert.setString( 1, iter.next() );
				psInsert.executeUpdate();
			}
			psInsert.close();
		}
		catch ( SQLException sqlEx ) {
			is.out.println( "<!-- " + Helper.throwable2String( sqlEx ) + "-->" );
			return LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_WHILE_SAVING_DATA" );
		}
		
		return null;
	}

	
	/**
	 * Saves changes for a callback hook
	 *
	 * @param is        session info (request parameters)
	 */
	static void doDelete( IMSession is ) {
		String id = is.request.getParameter( "cID" );
		if ( id == null || "".equals( id ) ) {
			return;
		}
		
		try {
			PreparedStatement psDeleteURL = IMEnv.getDB().prepareStatement( "DELETE FROM " +
					IMEnvBase.getEnv( "CALLBACKURLTBL" ) +
					" where CBNAME = '" + Helper.sqlEncode( id ) + "'" );
	
			PreparedStatement psDeleteRegistry = IMEnv.getDB().prepareStatement( "DELETE FROM " +
					IMEnvBase.getEnv( "CALLBACKREGISTRYTBL" ) +
					" where CBNAME = '" + Helper.sqlEncode( id ) + "'" );
			
			psDeleteURL.executeUpdate();
			psDeleteURL.close();
	
			psDeleteRegistry.executeUpdate();
			psDeleteRegistry.close();
			
			Properties logFields = new Properties();
			logFields.setProperty( "0LAC", "Delete" );
			logFields.setProperty( "0LTA", OperLogEntry.LEVEL.CALLBACK.getName() );
// we cannot use the ID to connect, because the record is physically deleted here			logFields.setProperty( "0LCN", id );
// so we use Information
			logFields.setProperty( "0LIN", "Name of the callback was:" + id );
			SchedulerInterface.logIntoTable( is, logFields );
		}
		catch ( SQLException sqlEx ) {
		}

	 }%><%

	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}

	String parBack = request.getParameter( "cBack" );
	if ( parBack == null ) {
		parBack = request.getHeader( "REFERER" );
	}
	if ( parBack == null ) {
		parBack = "javascript:self.history.back()";
	}
	
	if ( ! is.hasRight( IMTypeur.SUPPORT_RIGHT ) && ! is.hasRight( IMTypeur.ADMIN_RIGHT ) ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ), "imadmin/dicomsrv.jsp", null, parBack );
	}

	
	String parOp = request.getParameter( "cOper" );
	
	String errorMsg = null;
	
	if ( parOp != null ) {
		if ( parOp.startsWith( "save" ) ) {
			errorMsg = doSave( is );
			if ( errorMsg == null ) {
				parOp = null;
			}
			else {
				parOp = parOp.substring( 4 );
			}
		}
		else if ( parOp.equals( "deleteConfirmed" ) ) {
			doDelete( is );
		}
	}
	
%><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_PAGE_TITLE" ) %></TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
	imagemed.tables.Table.printCommonScript( is );
	TabToolbox.writeIMpopup( is.out );

	if ( "edit".equals( parOp ) || "new".equals( parOp ) ) {
		JSHelper.printJsInclude( out, "/imadmin/js/SelectFromList.js" );

		//the JavaScript from here was moved to SelectFromList.js
		
	}
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
%>

	<script language="JavaScript">//<![CDATA[
	
		function submitForm( oper ) {
			self.document.callbackFrm.cOper.value = oper;
			self.document.callbackFrm.submit();
		}

		function submitFormID( oper, id ) {
			self.document.callbackFrm.cID.value = id;
			submitForm( oper );
		}

		
	//]]></script>

	<STYLE type="text/css">

		table.Confirm {
			margin-left: auto;
			margin-right: auto;
			margin-top: 20px;
			text-align: left;
		}
		
	</STYLE>
</HEAD><BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicomsrv.jsp", "White" );

	String msgAddCallback = LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_ADD" );
%>
<FORM METHOD="POST" NAME="callbackFrm">
<%
	if ( "edit".equals( parOp ) || "new".equals( parOp ) ) {
		printEditPage( is, parOp, errorMsg );
	}
	else if ( "delete".equals( parOp ) ) {
		String id = is.request.getParameter( "cID" );
		if ( "".equals( id ) ) {
			id = null;
		}
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "IMADMIN_CALLBACK_DELETE" ), "60%", null, "Confirm" );
		if ( id == null || "".equals( id ) ) {
			mb.setMessage( "<DIV class=\"FontError\">" + LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ) + "</DIV>" );
		}
		else {
			mb.setMessage( LocalizedMessage.getCompoundMessage( "IMADMIN_CALLBACK_CONFIRM_DELETE", new Format[] { null }, new Object[] { "<i>" + id + "</i>" }, true ) );
			mb.addButton( new Button( "javascript:submitForm( 'deleteConfirmed', '" + id + "' );", "BUTTON_DELETE", "IMADMIN_CALLBACK_DELETE" ) );
		}
		
		mb.addButton( new Button( "javascript:submitForm( '' );", "BUTTON_CANCEL", "ALT_TEXT_CANCEL" ) );
		out.print( "<DIV style=\"text-align: center;\">" );
		mb.print( is.out );
		out.println( "</DIV>" );
		out.println( "<INPUT TYPE=HIDDEN NAME=cID VALUE=\"" + Helper.htmlEncode( id ) + "\" />" );
	}
	else {
		printListPage( is, parBack );
		out.println( "<INPUT TYPE=HIDDEN NAME=cID VALUE=\"\" />" );
	}

	String labelSelectAll = LocalizedMessage.getSimpleMessage( "GENERIC_SELECT_ALL" );
	String labelSelectNone = LocalizedMessage.getSimpleMessage( "GENERIC_SELECT_NONE" );
	
%>
<INPUT TYPE=HIDDEN NAME=cBack VALUE="<%= Helper.htmlEncode( parBack ) %>" />
<INPUT TYPE=HIDDEN NAME=cOper VALUE="" />
</FORM>
<%
  		JSHelper.printSelectFromListStuff( is );
%>
</BODY></HTML>
